<html>
<head>
<title>OgreInstanceBatchVTF.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreInstanceBatchVTF.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreInstanceBatchVTF_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __BaseInstanceBatchVTF_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __BaseInstanceBatchVTF_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreInstanceBatch_8h.html">OgreInstanceBatch.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre
<a name="l00035"></a>00035 {
<a name="l00074"></a><a class="code" href="classOgre_1_1BaseInstanceBatchVTF.html">00074</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1BaseInstanceBatchVTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) This implementation...">BaseInstanceBatchVTF</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a>
<a name="l00075"></a>00075     {
<a name="l00076"></a>00076     <span class="keyword">protected</span>:
<a name="l00077"></a><a class="code" href="group__Scene.html#ga8bcdb86a2070c884c85019cdd203aabf">00077</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;uint8&gt;::type</a> <a class="code" href="group__Scene.html#ga8bcdb86a2070c884c85019cdd203aabf">HWBoneIdxVec</a>;
<a name="l00078"></a><a class="code" href="group__Scene.html#ga7a7a999f7e059f08cb12a3027347dbba">00078</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;float&gt;::type</a> <a class="code" href="group__Scene.html#ga7a7a999f7e059f08cb12a3027347dbba">HWBoneWgtVec</a>;
<a name="l00079"></a><a class="code" href="group__Scene.html#ga53e4d4005e85c0b1e7f3baa67fc33436">00079</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;Matrix4&gt;::type</a> <a class="code" href="group__Scene.html#ga53e4d4005e85c0b1e7f3baa67fc33436">Matrix4Vec</a>;
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="group__Scene.html#ga3c4a0c0308cfb531cc68ee97f8209960">00081</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#ga3c4a0c0308cfb531cc68ee97f8209960">mMatricesPerInstance</a>; <span class="comment">//number of bone matrices per instance</span>
<a name="l00082"></a><a class="code" href="group__Scene.html#gae52c638c2cc24cc7f92806e1ee6b322a">00082</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#gae52c638c2cc24cc7f92806e1ee6b322a">mNumWorldMatrices</a>;  <span class="comment">//Num bones * num instances</span>
<a name="l00083"></a><a class="code" href="group__Scene.html#ga8440b4821b3f408548d6c09a7e13ad1e">00083</a>         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>              <a class="code" href="group__Scene.html#ga8440b4821b3f408548d6c09a7e13ad1e">mMatrixTexture</a>; <span class="comment">//The VTF</span>
<a name="l00084"></a>00084 
<a name="l00085"></a>00085         <span class="comment">//Used when all matrices from each instance must be in the same row (i.e. HW Instancing).</span>
<a name="l00086"></a>00086         <span class="comment">//A few pixels are wasted, but resizing the texture puts the danger of not sampling the</span>
<a name="l00087"></a>00087         <span class="comment">//right pixel... (in theory it should work, but in practice doesn&#39;t)</span>
<a name="l00088"></a><a class="code" href="group__Scene.html#ga403ea92c2e6d04a11623c29dc05c804d">00088</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#ga403ea92c2e6d04a11623c29dc05c804d">mWidthFloatsPadding</a>;
<a name="l00089"></a><a class="code" href="group__Scene.html#ga17fad70966b7ec3994ff56385dfdcb55">00089</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#ga17fad70966b7ec3994ff56385dfdcb55">mMaxFloatsPerLine</a>;
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="group__Scene.html#ga56fb118643f9c1477fc56975270ee42b">00091</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#ga56fb118643f9c1477fc56975270ee42b">mRowLength</a>;
<a name="l00092"></a><a class="code" href="group__Scene.html#ga68a6d86d89d1b1f6bdfbafa28cb105d5">00092</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#ga68a6d86d89d1b1f6bdfbafa28cb105d5">mWeightCount</a>;
<a name="l00093"></a>00093         <span class="comment">//Temporary array used to store 3x4 matrices before they are converted to dual quaternions</span>
<a name="l00094"></a><a class="code" href="group__Scene.html#ga91f832cdf49c3e74e631c6f49ab28c3e">00094</a>         <span class="keywordtype">float</span>*                  <a class="code" href="group__Scene.html#ga91f832cdf49c3e74e631c6f49ab28c3e">mTempTransformsArray3x4</a>;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         <span class="comment">// The state of the usage of bone matrix lookup</span>
<a name="l00097"></a><a class="code" href="group__Scene.html#ga4bd832d6809f220f60c43082dd9b032b">00097</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga4bd832d6809f220f60c43082dd9b032b">mUseBoneMatrixLookup</a>;
<a name="l00098"></a><a class="code" href="group__Scene.html#ga1e96698f2aa82e8ed3adbad1c3fd3f62">00098</a>         <span class="keywordtype">size_t</span> <a class="code" href="group__Scene.html#ga1e96698f2aa82e8ed3adbad1c3fd3f62">mMaxLookupTableInstances</a>;
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="group__Scene.html#ga842932c6daf717f2a0bcd372337153a0">00100</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga842932c6daf717f2a0bcd372337153a0">mUseBoneDualQuaternions</a>;
<a name="l00101"></a><a class="code" href="group__Scene.html#gae60067155d1a83bb5cb9bef9957cf33c">00101</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gae60067155d1a83bb5cb9bef9957cf33c">mForceOneWeight</a>;
<a name="l00102"></a><a class="code" href="group__Scene.html#ga82f3ba087317eec5c4bc129d4324ac7d">00102</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga82f3ba087317eec5c4bc129d4324ac7d">mUseOneWeight</a>;
<a name="l00103"></a>00103 
<a name="l00107"></a>00107         <span class="keywordtype">void</span> cloneMaterial( <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;material );
<a name="l00108"></a>00108 
<a name="l00113"></a>00113         <span class="keywordtype">void</span> retrieveBoneIdx( <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *baseVertexData, <a class="code" href="group__Scene.html#ga8bcdb86a2070c884c85019cdd203aabf">HWBoneIdxVec</a> &amp;outBoneIdx );
<a name="l00114"></a>00114 
<a name="l00119"></a>00119         <span class="keywordtype">void</span> retrieveBoneIdxWithWeights(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *baseVertexData, <a class="code" href="group__Scene.html#ga8bcdb86a2070c884c85019cdd203aabf">HWBoneIdxVec</a> &amp;outBoneIdx, <a class="code" href="group__Scene.html#ga7a7a999f7e059f08cb12a3027347dbba">HWBoneWgtVec</a> &amp;outBoneWgt);
<a name="l00120"></a>00120 
<a name="l00122"></a>00122         <span class="keywordtype">void</span> setupMaterialToUseVTF( <a class="code" href="group__Resources.html#gae50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> textureType, <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;material );
<a name="l00123"></a>00123 
<a name="l00125"></a>00125         <span class="keywordtype">void</span> createVertexTexture( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh );
<a name="l00126"></a>00126 
<a name="l00128"></a>00128         <span class="keyword">virtual</span> <span class="keywordtype">void</span> createVertexSemantics( <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *thisVertexData, <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *baseVertexData,
<a name="l00129"></a>00129                                     <span class="keyword">const</span> <a class="code" href="group__Scene.html#ga8bcdb86a2070c884c85019cdd203aabf">HWBoneIdxVec</a> &amp;hwBoneIdx, <span class="keyword">const</span> <a class="code" href="group__Scene.html#ga7a7a999f7e059f08cb12a3027347dbba">HWBoneWgtVec</a> &amp;hwBoneWgt) = 0;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131         <span class="keywordtype">size_t</span> convert3x4MatricesToDualQuaternions(<span class="keywordtype">float</span>* matrices, <span class="keywordtype">size_t</span> numOfMatrices, <span class="keywordtype">float</span>* outDualQuaternions);
<a name="l00132"></a>00132                                     
<a name="l00134"></a>00134         <span class="keywordtype">void</span> updateVertexTexture(<span class="keywordtype">void</span>);
<a name="l00135"></a>00135 
<a name="l00137"></a>00137         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> matricesToghetherPerRow() <span class="keyword">const</span> = 0;
<a name="l00138"></a>00138 
<a name="l00140"></a>00140         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateSharedLookupIndexes();
<a name="l00141"></a>00141 
<a name="l00143"></a>00143         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>* generateInstancedEntity(<span class="keywordtype">size_t</span> num);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145     <span class="keyword">public</span>:
<a name="l00146"></a>00146         <a class="code" href="classOgre_1_1BaseInstanceBatchVTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) This implementation...">BaseInstanceBatchVTF</a>( <a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a> *creator, <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> &amp;meshReference, <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;material,
<a name="l00147"></a>00147                             <span class="keywordtype">size_t</span> instancesPerBatch, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">Mesh::IndexMap</a> *indexToBoneMap,
<a name="l00148"></a>00148                             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;batchName);
<a name="l00149"></a>00149         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1BaseInstanceBatchVTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) This implementation...">BaseInstanceBatchVTF</a>();
<a name="l00150"></a>00150 
<a name="l00152"></a>00152         <span class="keywordtype">void</span> buildFrom( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> *baseSubMesh, <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> &amp;renderOperation );
<a name="l00153"></a>00153 
<a name="l00154"></a>00154         <span class="comment">//Renderable overloads</span>
<a name="l00155"></a>00155         <span class="keywordtype">void</span> getWorldTransforms( <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform ) <span class="keyword">const</span>;
<a name="l00156"></a>00156         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumWorldTransforms(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00157"></a>00157 
<a name="l00159"></a>00159         <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00160"></a>00160 
<a name="l00173"></a><a class="code" href="group__Scene.html#ga5bcd3f7c4a1280df27cdec94c5f18cb1">00173</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#ga5bcd3f7c4a1280df27cdec94c5f18cb1" title="Sets the state of the usage of bone matrix lookup.">setBoneMatrixLookup</a>(<span class="keywordtype">bool</span> enable, <span class="keywordtype">size_t</span> maxLookupTableInstances) { assert(mInstancedEntities.empty()); 
<a name="l00174"></a>00174             mUseBoneMatrixLookup = enable; mMaxLookupTableInstances = maxLookupTableInstances; }
<a name="l00175"></a>00175 
<a name="l00179"></a><a class="code" href="group__Scene.html#gaa0f7313ddefe803cda8ee41aa8ddc92d">00179</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gaa0f7313ddefe803cda8ee41aa8ddc92d" title="Tells whether to use bone matrix lookup.">useBoneMatrixLookup</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseBoneMatrixLookup; }
<a name="l00180"></a>00180 
<a name="l00181"></a><a class="code" href="group__Scene.html#ga61b8f8dd2a76aefe958083ad37d364fd">00181</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#ga61b8f8dd2a76aefe958083ad37d364fd">setBoneDualQuaternions</a>(<span class="keywordtype">bool</span> enable) { assert(mInstancedEntities.empty());
<a name="l00182"></a>00182             mUseBoneDualQuaternions = enable; mRowLength = (mUseBoneDualQuaternions ? 2 : 3); }
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="group__Scene.html#ga1df9c1f7388598dba32f11a84fcaf803">00184</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga1df9c1f7388598dba32f11a84fcaf803">useBoneDualQuaternions</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseBoneDualQuaternions; }
<a name="l00185"></a>00185 
<a name="l00186"></a><a class="code" href="group__Scene.html#gae413c69ac3cf2e61ffd5eaf3c3842dd2">00186</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#gae413c69ac3cf2e61ffd5eaf3c3842dd2">setForceOneWeight</a>(<span class="keywordtype">bool</span> enable) {  assert(mInstancedEntities.empty());
<a name="l00187"></a>00187             mForceOneWeight = enable; }
<a name="l00188"></a>00188 
<a name="l00189"></a><a class="code" href="group__Scene.html#ga418f0e38a8180b2e159699695e0f203b">00189</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga418f0e38a8180b2e159699695e0f203b">forceOneWeight</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mForceOneWeight; }
<a name="l00190"></a>00190 
<a name="l00191"></a><a class="code" href="group__Scene.html#gaf23de70598e81b12eb2760a5d9bc4c22">00191</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#gaf23de70598e81b12eb2760a5d9bc4c22">setUseOneWeight</a>(<span class="keywordtype">bool</span> enable) {  assert(mInstancedEntities.empty());
<a name="l00192"></a>00192             mUseOneWeight = enable; }
<a name="l00193"></a>00193 
<a name="l00194"></a><a class="code" href="group__Scene.html#gaa56311b09d89ab161cb6ef4c865b8b3c">00194</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gaa56311b09d89ab161cb6ef4c865b8b3c">useOneWeight</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseOneWeight; }
<a name="l00195"></a>00195 
<a name="l00197"></a><a class="code" href="group__Scene.html#gab00a408e616ab82803023d2132ad1ea4">00197</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gab00a408e616ab82803023d2132ad1ea4">useBoneWorldMatrices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !mUseBoneMatrixLookup; }
<a name="l00198"></a>00198 
<a name="l00200"></a><a class="code" href="group__Scene.html#gab5bc06683d655efca93981df0f59a945">00200</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="group__Scene.html#gab5bc06683d655efca93981df0f59a945">getMaxLookupTableInstances</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaxLookupTableInstances; }
<a name="l00201"></a>00201         
<a name="l00202"></a>00202     };
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classOgre_1_1InstanceBatchVTF.html">00204</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1InstanceBatchVTF.html">InstanceBatchVTF</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1BaseInstanceBatchVTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) This implementation...">BaseInstanceBatchVTF</a>
<a name="l00205"></a>00205     {
<a name="l00206"></a>00206         
<a name="l00207"></a>00207         <span class="keywordtype">void</span> setupVertices( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh );
<a name="l00208"></a>00208         <span class="keywordtype">void</span> setupIndices( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh );
<a name="l00209"></a>00209 
<a name="l00211"></a>00211         <span class="keywordtype">void</span> createVertexSemantics( <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *thisVertexData, <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *baseVertexData,
<a name="l00212"></a>00212             <span class="keyword">const</span> <a class="code" href="group__Scene.html#ga8bcdb86a2070c884c85019cdd203aabf">HWBoneIdxVec</a> &amp;hwBoneIdx, <span class="keyword">const</span> <a class="code" href="group__Scene.html#ga7a7a999f7e059f08cb12a3027347dbba">HWBoneWgtVec</a> &amp;hwBoneWgt );
<a name="l00213"></a>00213 
<a name="l00214"></a><a class="code" href="group__Scene.html#gaaa0b1593d3fc4f61a65d4a18c1e9f881">00214</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gaaa0b1593d3fc4f61a65d4a18c1e9f881" title="Affects VTF texture&#39;s width dimension.">matricesToghetherPerRow</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00215"></a>00215     <span class="keyword">public</span>:
<a name="l00216"></a>00216         <a class="code" href="classOgre_1_1InstanceBatchVTF.html">InstanceBatchVTF</a>( <a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a> *creator, <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> &amp;meshReference, <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;material,
<a name="l00217"></a>00217                             <span class="keywordtype">size_t</span> instancesPerBatch, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">Mesh::IndexMap</a> *indexToBoneMap,
<a name="l00218"></a>00218                             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;batchName);
<a name="l00219"></a>00219         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1InstanceBatchVTF.html">InstanceBatchVTF</a>();
<a name="l00220"></a>00220 
<a name="l00222"></a>00222         <span class="keywordtype">size_t</span> calculateMaxNumInstances( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> *baseSubMesh, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> flags ) <span class="keyword">const</span>;
<a name="l00223"></a>00223     };
<a name="l00224"></a>00224 }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
